Index: src/main/java/com/tourMate/config/SecurityConfig.java
===================================================================
--- src/main/java/com/tourMate/config/SecurityConfig.java	(revision 5528b99794e1d3a36baa8eb2f1829125b75f0174)
+++ src/main/java/com/tourMate/config/SecurityConfig.java	(revision 07f4e8b52fa18ab7781f9660c09d7982d8cd5a0b)
@@ -5,6 +5,6 @@
 import org.springframework.context.annotation.Bean;
 import org.springframework.context.annotation.Configuration;
-import org.springframework.http.HttpHeaders;
 import org.springframework.http.HttpMethod;
+import org.springframework.http.HttpStatus;
 import org.springframework.security.config.annotation.web.builders.HttpSecurity;
 import org.springframework.security.config.annotation.web.configuration.EnableWebSecurity;
@@ -13,5 +13,5 @@
 import org.springframework.security.crypto.password.PasswordEncoder;
 import org.springframework.security.web.SecurityFilterChain;
-import org.springframework.security.web.authentication.UsernamePasswordAuthenticationFilter;
+import org.springframework.security.web.authentication.logout.HttpStatusReturningLogoutSuccessHandler;
 import org.springframework.security.web.util.matcher.AntPathRequestMatcher;
 import org.springframework.web.cors.CorsConfiguration;
@@ -21,9 +21,13 @@
 import java.util.Arrays;
 
-import static org.springframework.security.config.Customizer.withDefaults;
-
 @Configuration
 @EnableWebSecurity
 public class SecurityConfig {
+
+    private final UserSecurity userSecurity;
+
+    public SecurityConfig(UserSecurity userSecurity) {
+        this.userSecurity = userSecurity;
+    }
 
     @Bean
@@ -64,6 +68,6 @@
                             try {
                                 authz
-                                        .requestMatchers(new AntPathRequestMatcher("/1/hasBusiness")).permitAll()
-                                        .requestMatchers(new AntPathRequestMatcher("/business/1/unapproved")).permitAll()
+                                        .requestMatchers(new AntPathRequestMatcher("/{userId}/hasBusiness")).access(userSecurity)
+                                        .requestMatchers(new AntPathRequestMatcher("/business/*/unapproved")).permitAll()
                                         .requestMatchers(new AntPathRequestMatcher("/register")).permitAll()
                                         .requestMatchers(new AntPathRequestMatcher("/hotel/search")).permitAll()
@@ -71,11 +75,15 @@
                                         .requestMatchers(new AntPathRequestMatcher("/restaurant/search")).permitAll()
                                         .requestMatchers(new AntPathRequestMatcher("/upload")).permitAll()
-                                        .requestMatchers(new AntPathRequestMatcher("/business/*")).hasAnyAuthority("SUPERADMIN")
-                                        .anyRequest().authenticated()
+                                        .requestMatchers(new AntPathRequestMatcher("/business/approve/*")).hasAnyAuthority("SUPERADMIN")
+                                        .requestMatchers(new AntPathRequestMatcher("/business/add/*")).authenticated()
+                                        .requestMatchers(new AntPathRequestMatcher("/*/user/{userId}")).access(userSecurity)
+                                        .anyRequest().permitAll()
+//                                        .anyRequest().authenticated()
                                         .and()
-                                        .formLogin().loginPage("http://localhost:3000/login")
+                                        .formLogin()
                                         .loginProcessingUrl("/api/login").usernameParameter("username").passwordParameter("password")
                                         .successHandler((request, response, authentication) -> {
                                             response.setStatus(HttpServletResponse.SC_OK);
+                                            response.setCharacterEncoding("UTF-8");
                                             response.setContentType("application/json");
                                             response.getWriter().print("{\"message\": \"Login successful\",");
@@ -85,5 +93,6 @@
                                         .failureHandler((request, response, exception) -> {
                                             response.setStatus(HttpServletResponse.SC_UNAUTHORIZED);
-                                            response.getWriter().print("Pukla veza\n" + exception.getMessage());
+                                            response.sendRedirect("/login");
+                                            response.getWriter().print("Neuspesna najava\n" + exception.getMessage());
                                             response.getWriter().flush();
                                         })
@@ -93,5 +102,5 @@
                                         .sessionCreationPolicy(SessionCreationPolicy.ALWAYS)
                                         .and()
-                                        .logout()
+                                        .logout().logoutSuccessHandler((new HttpStatusReturningLogoutSuccessHandler(HttpStatus.OK)))
                                         .permitAll();
 
Index: src/main/java/com/tourMate/config/UserSecurity.java
===================================================================
--- src/main/java/com/tourMate/config/UserSecurity.java	(revision 07f4e8b52fa18ab7781f9660c09d7982d8cd5a0b)
+++ src/main/java/com/tourMate/config/UserSecurity.java	(revision 07f4e8b52fa18ab7781f9660c09d7982d8cd5a0b)
@@ -0,0 +1,33 @@
+package com.tourMate.config;
+
+import com.tourMate.entities.Hotels;
+import com.tourMate.entities.User;
+import com.tourMate.services.HotelManager;
+import org.springframework.beans.factory.annotation.Autowired;
+import org.springframework.security.authorization.AuthorizationDecision;
+import org.springframework.security.authorization.AuthorizationManager;
+import org.springframework.security.core.Authentication;
+import org.springframework.security.web.access.intercept.RequestAuthorizationContext;
+import org.springframework.stereotype.Component;
+
+import java.util.function.Supplier;
+
+@Component
+public class UserSecurity implements AuthorizationManager<RequestAuthorizationContext> {
+
+    @Override
+    public AuthorizationDecision check(Supplier authenticationSupplier, RequestAuthorizationContext ctx) {
+        Long userId = Long.parseLong(ctx.getVariables().get("userId"));
+        Authentication authentication = (Authentication) authenticationSupplier.get();
+        return new AuthorizationDecision(hasUserId(authentication, userId));
+    }
+
+    public boolean hasUserId(Authentication authentication, Long userId) {
+        System.out.println(userId);
+        User user = (User) authentication.getPrincipal();
+        System.out.println(user.getUserID());
+        System.out.println(authentication.getPrincipal());
+        return userId == user.getUserID();
+    }
+
+}
Index: src/main/java/com/tourMate/controllers/HotelController.java
===================================================================
--- src/main/java/com/tourMate/controllers/HotelController.java	(revision 5528b99794e1d3a36baa8eb2f1829125b75f0174)
+++ src/main/java/com/tourMate/controllers/HotelController.java	(revision 07f4e8b52fa18ab7781f9660c09d7982d8cd5a0b)
@@ -2,4 +2,6 @@
 
 import com.tourMate.dto.HotelDto;
+import com.tourMate.dto.HotelReservationDto;
+import com.tourMate.dto.HotelReservationUserDto;
 import com.tourMate.entities.*;
 import com.tourMate.services.HotelManager;
@@ -50,5 +52,5 @@
     }
 
-    @GetMapping(path = "/hotel/list/{id}")
+    @GetMapping(path = "/hotel/{id}/list")
     public ResponseEntity<Hotels> getHotelById (@PathVariable(name = "id") long hotelId)
     {
@@ -104,7 +106,8 @@
     //HOTEL ROOM CRUD
     @PostMapping(path = "/hotel/rooms/add")
-    public void addRoom(@RequestBody HotelRoom room, @RequestParam(name = "hotelId") long hotelId) {
+    public void addRoom(@RequestBody HotelRoom room,
+                        @RequestParam(name = "hotelId") long hotelId) {
         Hotels h = hotelManager.findHotelByID(hotelId);
-        hotelManager.createRoom(h, room.getHotelRoomDescription(), room.getHotelRoomName(), room.getKitchenAvailable(), room.getAirConditioning(), room.getBalcony(), room.getPrice());
+        hotelManager.createRoom(h, room.getHotelRoomDescription(), room.getHotelRoomName(), room.getKitchenAvailable(), room.getAirConditioning(), room.getBalcony(), room.getPrice(), room.getNumOfBeds());
     }
 
@@ -149,5 +152,6 @@
         //HOTEL AVAILABILITY CRUD
     @PostMapping(path = "/hotel/rooms/available/{id}/add")
-    public void addRoomAvailible(@RequestBody HotelRoomAvailable hotelRoomAvailable, @PathVariable long id)
+    public void addRoomAvailible(@RequestBody HotelRoomAvailable hotelRoomAvailable,
+                                 @PathVariable long id)
     {
         HotelRoom hotelRoom = hotelManager.findRoomById(id);
@@ -178,14 +182,17 @@
     public List<HotelRoomAvailable> getRoomAvailability(@PathVariable Long id)
     {
-        return hotelManager.getRoomsAvailibility();
+        return hotelManager.getRoomsAvailableById(id);
     }
 
     @GetMapping(path = "/hotel/search")
-    public List<HotelDto> searchAvailibleRooms(@RequestParam(name = "hotelLocation") String hotelLocation, @RequestParam(name = "dateFrom") @DateTimeFormat(pattern = "yyyy-MM-dd") Date dateFrom,
-                                               @RequestParam(name = "dateTo") @DateTimeFormat(pattern = "yyyy-MM-dd") Date dateTo, @RequestParam(name = "numBeds") int numBeds)
-    {
-        System.out.println(hotelLocation);
+    public List<HotelDto> searchAvailibleRooms(@RequestParam(name = "hotelLocation") String hotelLocation,
+                                               @RequestParam(name = "dateFrom") @DateTimeFormat(pattern = "yyyy-MM-dd") Date dateFrom,
+                                               @RequestParam(name = "dateTo") @DateTimeFormat(pattern = "yyyy-MM-dd") Date dateTo,
+                                               @RequestParam(name = "numBeds") int numBeds,
+                                               @RequestParam(name = "flexible") Boolean flexible)
+    {
+        System.out.println(flexible);
         System.out.println(dateFrom + " " + dateTo);
-        return hotelManager.getRoomsAvailibilityByDateAndLocation(hotelLocation, dateFrom, dateTo, numBeds);
+        return hotelManager.getRoomsAvailibilityByDateAndLocation(hotelLocation, dateFrom, dateTo, numBeds, flexible);
     }
 
@@ -203,5 +210,4 @@
     }
 
-<<<<<<< HEAD
     @GetMapping(path = "/hotel/{id}/reservations/active")
     public List<HotelReservationDto> getActiveReservationsForHotel(@PathVariable Long id)
@@ -233,5 +239,9 @@
         return hotelManager.getRoomImages(id);
     }
-=======
->>>>>>> parent of ac19a0c (authContext impl, admin panel impl, search bar fixes, reservations listings impl)
+
+    @PostMapping("/hotel/{id}/cancel")
+    public void cancelHotelReservation(@PathVariable Long id){
+        hotelManager.deleteReservation(id);
+    }
+
 }
Index: src/main/java/com/tourMate/controllers/RestaurantController.java
===================================================================
--- src/main/java/com/tourMate/controllers/RestaurantController.java	(revision 5528b99794e1d3a36baa8eb2f1829125b75f0174)
+++ src/main/java/com/tourMate/controllers/RestaurantController.java	(revision 07f4e8b52fa18ab7781f9660c09d7982d8cd5a0b)
@@ -1,5 +1,7 @@
 package com.tourMate.controllers;
 
+import com.tourMate.dto.HotelReservationDto;
 import com.tourMate.dto.RestaurantDto;
+import com.tourMate.dto.RestaurantReservationDto;
 import com.tourMate.dto.RestaurantReservationUserDto;
 import com.tourMate.entities.*;
@@ -34,4 +36,9 @@
     }
 
+    @PostMapping("/restaurant/{id}/cancel")
+    public void removeRestaurant(@PathVariable Long id){
+        restaurantManager.deleteReservation(id);
+    }
+
     @GetMapping(path = "/restaurant")
     public List<Restaurant> showRestaurants() {
@@ -42,5 +49,5 @@
     public List<Restaurant> showRestaurantsForUser(@PathVariable(name = "id") long userId) {
 
-        return restaurantManager.getRestaurants();
+        return restaurantManager.getRestaurantsByUser(userId);
     }
 
@@ -133,5 +140,5 @@
                                   @PathVariable Long id) {
         System.out.println(restaurantsAvailible.getHourFrom() + " " + restaurantsAvailible.getHourTo());
-        restaurantManager.createTableAvailable(id, restaurantsAvailible.getHourFrom(), restaurantsAvailible.getHourTo());
+        restaurantManager.createTableAvailable(id, restaurantsAvailible.getHourFrom(), restaurantsAvailible.getHourTo(), restaurantsAvailible.getNumTables());
     }
 
@@ -170,4 +177,16 @@
         return restaurantManager.getRestaurantImages(id);
     }
+
+    @GetMapping(path = "/menu/{id}/images")
+    public List<MenuImages> getImagesForMenu(@PathVariable Long id)
+    {
+        return restaurantManager.getMenuImages(id);
+    }
+
+    @GetMapping(path = "/restaurant/{id}/reservations/active")
+    public List<RestaurantReservationDto> getActiveReservationsForHotel(@PathVariable Long id)
+    {
+        return restaurantManager.findReservationByRestaurant(id);
+    }
 }
 
Index: src/main/java/com/tourMate/controllers/ReviewController.java
===================================================================
--- src/main/java/com/tourMate/controllers/ReviewController.java	(revision 5528b99794e1d3a36baa8eb2f1829125b75f0174)
+++ src/main/java/com/tourMate/controllers/ReviewController.java	(revision 07f4e8b52fa18ab7781f9660c09d7982d8cd5a0b)
@@ -20,6 +20,7 @@
                     @RequestParam(name = "hotelId", required = false) Long hotelId,
                     @RequestParam(name = "restaurantId", required = false) Long restaurantId,
-                    @RequestParam(name = "transportId", required = false) Long transportId ) {
-        reviewManager.createReview(title, numStars, description, hotelId, restaurantId, transportId);
+                    @RequestParam(name = "transportId", required = false) Long transportId,
+                    @RequestParam(name = "reservationId") Long reservationId) {
+        reviewManager.createReview(title, numStars, description, hotelId, restaurantId, transportId, reservationId);
     }
 
Index: src/main/java/com/tourMate/controllers/TransportController.java
===================================================================
--- src/main/java/com/tourMate/controllers/TransportController.java	(revision 5528b99794e1d3a36baa8eb2f1829125b75f0174)
+++ src/main/java/com/tourMate/controllers/TransportController.java	(revision 07f4e8b52fa18ab7781f9660c09d7982d8cd5a0b)
@@ -20,7 +20,8 @@
 
     // TRANSPORT CRUD //
-    @PostMapping(path = "/transport/add")
-    public void add(@RequestBody Transport transport) {
-        transportManager.createTransport(transport.getTransportName(), transport.getCarBrand(), transport.getCarType(), transport.getCarManufacturedYear(), transport.getNoPassengers(), transport.getNoBags(), transport.getEMBG(), new User(), transport.getCarPlate());
+    @PostMapping(path = "/transport/add/{userId}")
+    public void add(@RequestBody Transport transport,
+                    @PathVariable Long userId) {
+        transportManager.createTransport(transport.getTransportName(), transport.getCarBrand(), transport.getCarType(), transport.getCarManufacturedYear(), transport.getNoPassengers(), transport.getNoBags(), transport.getEMBG(), userId, transport.getCarPlate());
 
     }
@@ -45,5 +46,4 @@
     public TransportDto getTransport(@PathVariable(name = "id") long transportId)
     {
-        System.out.println("TUKA SUUUUUM");
         return transportManager.findTransportById(transportId);
     }
@@ -84,6 +84,4 @@
     @PostMapping(path = "/transport/available/add")
     public void add(@RequestBody TransportAvailible transportAvailable, @RequestParam(name = "transportId") long transportId) {
-        System.out.println("OREEEEEL");
-        System.out.println("DVA ORLA");
         Transport t = transportManager.getTransportById(transportId);
         List<TransportRoute> routes = transportAvailable.getRoutes().stream().toList();
@@ -127,7 +125,9 @@
 
     @GetMapping(path = "/transport/search")
-    public List<TransportListingDto> searchAvailableTransport(@RequestParam(name = "from") String from, @RequestParam(name = "to") String to,
-                                                              @RequestParam(name = "date") @DateTimeFormat(pattern = "yyyy-MM-dd") Date date){
-        return transportManager.getTransportsAvailableByFilters(from, to, date);
+    public List<TransportListingDto> searchAvailableTransport(@RequestParam(name = "from") String from,
+                                                              @RequestParam(name = "to") String to,
+                                                              @RequestParam(name = "date") @DateTimeFormat(pattern = "yyyy-MM-dd") Date date,
+                                                              @RequestParam(name = "numPassengers") int numPassengers){
+        return transportManager.getTransportsAvailableByFilters(from, to, date, numPassengers);
     }
 
@@ -151,3 +151,8 @@
         return transportManager.findPastTransportReservationsByUser(id);
     }
+
+    @GetMapping(path = "/transport/{id}/reservations/active")
+    public List<TransportReservation> showTransportReservationsByTransport(@PathVariable Long id) {
+        return transportManager.findTransportReservationByTransportId(id);
+    }
 }
Index: src/main/java/com/tourMate/controllers/UsersController.java
===================================================================
--- src/main/java/com/tourMate/controllers/UsersController.java	(revision 5528b99794e1d3a36baa8eb2f1829125b75f0174)
+++ src/main/java/com/tourMate/controllers/UsersController.java	(revision 07f4e8b52fa18ab7781f9660c09d7982d8cd5a0b)
@@ -11,5 +11,4 @@
 import org.springframework.web.bind.annotation.*;
 
-import java.util.ArrayList;
 import java.util.List;
 
@@ -39,4 +38,32 @@
     {
         return businessManager.getUnapprovedBusinessesOfUser(userId);
+    }
+
+    @GetMapping(path = "/business/unapproved")
+    public List<Business> getAllUnapprovedBusinesses()
+    {
+        return businessManager.getUnapprovedBusinesses();
+    }
+
+    @GetMapping(path = "/users/unapproved")
+    public List<User> getAllUnapprovedUsers()
+    {
+        return usersManager.getUnapprovedUsers();
+    }
+
+    @GetMapping(path = "/users/approve/{userId}")
+    public ResponseEntity<?> approveUserProfile(@PathVariable Long userId)
+    {
+        usersManager.approveUserProfile(userId);
+        return new ResponseEntity<>(HttpStatus.OK);
+
+
+    }
+
+    @GetMapping(path = "/business/approve/{businessId}")
+    public ResponseEntity<?> approveBusiness(@PathVariable Long businessId)
+    {
+        businessManager.approveBusiness(businessId);
+        return new ResponseEntity<>(HttpStatus.OK);
     }
 
@@ -85,4 +112,11 @@
         }
     }
+
+    @GetMapping("/users/unlock/{id}")
+    public ResponseEntity unlock(@PathVariable Long id)
+    {
+        usersManager.unlock(id);
+        return new ResponseEntity(HttpStatus.OK);
+    }
 }
 
Index: src/main/java/com/tourMate/dao/BusinessDao.java
===================================================================
--- src/main/java/com/tourMate/dao/BusinessDao.java	(revision 5528b99794e1d3a36baa8eb2f1829125b75f0174)
+++ src/main/java/com/tourMate/dao/BusinessDao.java	(revision 07f4e8b52fa18ab7781f9660c09d7982d8cd5a0b)
@@ -9,14 +9,23 @@
 public interface BusinessDao {
 
-    @Transactional
-    void createBusiness(Business business, long userId);
-    public List<Business> getUnapprovedBusinessesOfUser(long userId);
-    public void deleteBusiness(long businessId);
-    public List<Business> getCreatedBusinesses();
-    public Business findBusinessById (long businessId);
+    List<Business> getCreatedBusinesses();
+
+    Business findBusinessById(long businessId);
 
     @Transactional
-    void editBusiness(long businessId, String name, String phone, String address, String edbs, User user, boolean approved);
-    public boolean hasBusiness(long userId);
+    void createBusiness(Business business);
 
+    List<Business> getUnapprovedBusinessesOfUser(User u);
+
+    @Transactional
+    void deleteBusiness(Business business);
+
+    boolean hasBusiness(User u);
+
+    List<Business> getUnapprovedBusinesses();
+
+    void approveBusiness(Business business);
+
+    @Transactional
+    void editBusiness(Business business);
 }
Index: src/main/java/com/tourMate/dao/HotelDao.java
===================================================================
--- src/main/java/com/tourMate/dao/HotelDao.java	(revision 5528b99794e1d3a36baa8eb2f1829125b75f0174)
+++ src/main/java/com/tourMate/dao/HotelDao.java	(revision 07f4e8b52fa18ab7781f9660c09d7982d8cd5a0b)
@@ -9,47 +9,136 @@
 
 public interface HotelDao {
-    public void createHotel(Hotels hotel, long userId);
-    public void editHotel(long hotelId, String hotelName, String hotelDescripiton, String hotelLocation, String hotelEDBS, Boolean parking, Boolean petFriendly, Boolean internetAvailable);
-    public void deleteHotel(long hotelId);
-    public Hotels findHotelByID (long hotelId);
-    public List<Hotels> getHotels();
-    public List<Hotels> getHotelsForUser(long userId);
-    public List<Hotels> getHotelsByLocation(String hotelLocation);
+    @Transactional
+    void createHotel(Hotels hotel);
 
-    public void deleteHotelImage(long hotelImageId);
-    public HotelsImages findHotelImageById(long hotelImageId);
-    public List<HotelsImages> getHotelImages(Hotels hotels);
-    public List<HotelRoomImages> getRoomImages(HotelRoom hotelRoom);
+    List<Hotels> getHotels();
 
-    public void createRoom(Hotels hotel, String hotelRoomDescription, String hotelRoomName, Boolean kitchenAvailable, Boolean airConditioning, Boolean balcony, double price);
-    public void editRoom(long hotelRoomId, Hotels hotel, String hotelRoomDescription, String HotelRoomName, Boolean kitchenAvailable, Boolean airConditioning, Boolean balcony, double price);
-    public void deleteRoom(long hotelRoomId);
-    public HotelRoom findRoomById (long hotelRoomId);
-    public List<HotelRoom> getRoomsOfHotel (long hotelId);
-    public List<HotelRoomAvailable> getRoomsAvailable(Long id);
+    List<Hotels> getHotelsForUser(User u);
+
+    List<Hotels> getHotelsByLocation(String hotelLocation);
 
     @Transactional
-    public void createRoomAvailible(HotelRoom hotelRoom, Date dateFrom, Date dateTo, int numberOfBeds);
-    public void editRoomAvailible(long hotelRoomAvailableId, HotelRoom hotelRoom, Date dateFrom, Date dateTo, int numberOfBeds);
-    public void deleteRoomAvailible(long hotelRoomAvailableId);
-    public HotelRoomAvailable findAvailibleRoomById(long hotelRoomAvailableId);
-    public List<HotelRoomAvailable> getRoomsAvailibility();
-    public List<HotelRoomAvailable> getRoomsAvailibilityByHotel(Hotels hotel);
-    public List<HotelRoomAvailable> getRoomsAvailibilityByDateAndLocation(String hotelLocation, Date dateFrom, Date dateTo, int numberOfBeds);
+    void editHotel(Hotels hotel);
 
-    public void createReservation(User user, HotelRoom hotelRoom, Date dateFrom, Date dateTo, Integer numberOfBeds);
-    public void editReservation(long hotelRoomReservedId, User user, HotelRoom hotelRoom, Date dateFrom, Date dateTo, Integer numberOfBeds);
-    public void deleteReservation(long hotelRoomReservedId);
-    public HotelRoomReservations findReservationById(long hotelRoomReservedId);
-    public List<HotelRoomReservations> findReservationByUser(User user);
-    public List<HotelRoomReservations> findReservationByHotel(Hotels hotel);
-    public List<HotelRoomReservations> getReservations();
+    @Transactional
+    void deleteHotel(Hotels hotel);
+
+    Hotels findHotelByID(long hotelId);
+
+    List<HotelsImages> getHotelImages(Hotels hotel);
+
+    @Transactional
+    void addHotelImage(HotelsImages image);
+
+    @Transactional
+    void addRoomImage(HotelRoomImages x);
+
+    @Transactional
+    void  saveReservation(HotelRoomReservations hotelRoomReservations);
+
+    @Transactional
+    HotelsImages findHotelImageById(long hotelImageId);
+
+    @Transactional
+    void deleteHotelImage(HotelsImages hotelsImages);
+
+    List<HotelRoom> getRoomsOfHotel(Hotels hotel);
+
+    List<HotelRoomAvailable> getRoomsAvailable(Long id);
+
+    HotelRoom findRoomById(long hotelRoomId);
+
+    List<HotelRoomImages> getRoomImages(HotelRoom hotelRoom);
+
+    @Transactional
+    void createRoom(HotelRoom hotelRoom);
+
+    @Transactional
+    void editRoom(HotelRoom hr);
+
+    @Transactional
+    void deleteRoom(HotelRoom hr);
+
+    @Transactional
+    void createRoomAvailible(HotelRoomAvailable hra);
+
+    @Transactional
+    void editRoomAvailible(HotelRoomAvailable hr);
+
+    @Transactional
+    void deleteRoomAvailible(HotelRoomAvailable hra);
+
+    HotelRoomAvailable findAvailibleRoomById(long hotelRoomAvailableId);
+
+    List<HotelRoomAvailable> getRoomsAvailibility();
+
+    List<HotelRoomAvailable> getRoomsAvailibilityByHotel(Hotels hotel);
+
+    List<HotelRoomAvailable> getRoomsAvailibilityByDateAndLocation(String hotelLocation, Date dateFrom, Date dateTo, int numberOfBeds, Boolean flexible);
+
+    @Transactional
+    void createReservation(HotelRoomReservations r);
+
+    @Transactional
+    void editReservation(HotelRoomReservations hr);
+
+    @Transactional
+    void deleteReservation(HotelRoomReservations hr);
+
+    HotelRoomReservations findReservationById(long hotelRoomReservedId);
+
+    List<HotelRoomReservations> findReservationByUser(User user);
+
+    List<HotelRoomReservations> findReservationByHotel(Hotels hotel);
+
+    List<HotelRoomReservations> getReservations();
 
     List<Reviews> findReviewsByHotel(Hotels hotel);
 
     List<HotelRoomReservations> findPastReservationByUser(User u);
-
-    void addHotelImage(HotelsImages x);
-
-    void addRoomImage(HotelRoomImages x);
+//    public void createHotel(Hotels hotel, long userId);
+//    public void editHotel(long hotelId, String hotelName, String hotelDescripiton, String hotelLocation, String hotelEDBS, Boolean parking, Boolean petFriendly, Boolean internetAvailable);
+//    public void deleteHotel(long hotelId);
+//    public Hotels findHotelByID (long hotelId);
+//    public List<Hotels> getHotels();
+//    public List<Hotels> getHotelsForUser(long userId);
+//    public List<Hotels> getHotelsByLocation(String hotelLocation);
+//
+//    public void deleteHotelImage(long hotelImageId);
+//    public HotelsImages findHotelImageById(long hotelImageId);
+//    public List<HotelsImages> getHotelImages(Hotels hotels);
+//    public List<HotelRoomImages> getRoomImages(HotelRoom hotelRoom);
+//
+//    public void createRoom(Hotels hotel, String hotelRoomDescription, String hotelRoomName, Boolean kitchenAvailable, Boolean airConditioning, Boolean balcony, double price, int numOfBeds);
+//    public void editRoom(long hotelRoomId, Hotels hotel, String hotelRoomDescription, String HotelRoomName, Boolean kitchenAvailable, Boolean airConditioning, Boolean balcony, double price);
+//    public void deleteRoom(long hotelRoomId);
+//    public HotelRoom findRoomById (long hotelRoomId);
+//    public List<HotelRoom> getRoomsOfHotel (long hotelId);
+//    public List<HotelRoomAvailable> getRoomsAvailable(Long id);
+//
+//    @Transactional
+//    public void createRoomAvailible(HotelRoom hotelRoom, Date dateFrom, Date dateTo, int numberOfBeds);
+//    public void editRoomAvailible(long hotelRoomAvailableId, HotelRoom hotelRoom, Date dateFrom, Date dateTo, int numberOfBeds);
+//    public void deleteRoomAvailible(long hotelRoomAvailableId);
+//    public HotelRoomAvailable findAvailibleRoomById(long hotelRoomAvailableId);
+//    public List<HotelRoomAvailable> getRoomsAvailibility();
+//    public List<HotelRoomAvailable> getRoomsAvailibilityByHotel(Hotels hotel);
+//    public List<HotelRoomAvailable> getRoomsAvailibilityByDateAndLocation(String hotelLocation, Date dateFrom, Date dateTo, int numberOfBeds, Boolean flexible);
+//
+//    public void createReservation(User user, HotelRoom hotelRoom, Date dateFrom, Date dateTo, Integer numberOfBeds);
+//    public void editReservation(long hotelRoomReservedId, User user, HotelRoom hotelRoom, Date dateFrom, Date dateTo, Integer numberOfBeds);
+//    public void deleteReservation(long hotelRoomReservedId);
+//    public HotelRoomReservations findReservationById(long hotelRoomReservedId);
+//    public List<HotelRoomReservations> findReservationByUser(User user);
+//    public List<HotelRoomReservations> findReservationByHotel(Hotels hotel);
+//    public List<HotelRoomReservations> getReservations();
+//
+//    List<Reviews> findReviewsByHotel(Hotels hotel);
+//
+//    List<HotelRoomReservations> findPastReservationByUser(User u);
+//
+//    void addHotelImage(HotelsImages x);
+//
+//    void addRoomImage(HotelRoomImages x);
+//    void saveReservation(HotelRoomReservations hotelRoomReservations);
 }
Index: src/main/java/com/tourMate/dao/MenuDao.java
===================================================================
--- src/main/java/com/tourMate/dao/MenuDao.java	(revision 5528b99794e1d3a36baa8eb2f1829125b75f0174)
+++ src/main/java/com/tourMate/dao/MenuDao.java	(revision 07f4e8b52fa18ab7781f9660c09d7982d8cd5a0b)
@@ -2,12 +2,33 @@
 
 import com.tourMate.entities.Menu;
+import jakarta.transaction.Transactional;
 
 import java.util.List;
 
 public interface MenuDao {
-    public void createMenu(String name, String ingredients, double price);
-    public void deleteMenu(long menuId);
-    public List<Menu> getCreatedMenus();
-    public Menu findMenuById(long menuId);
-    public void editMenu(long menuId, String name, String ingredients, double price);
+    @Transactional
+    void createMenu(Menu menu);
+
+    @Transactional
+    void deleteMenu(Menu menu);
+
+    List<Menu> getCreatedMenus();
+
+    Menu findMenuById(long menuId);
+
+    @Transactional
+    void editMenu(Menu menu);
+//    public void createMenu(String name, String ingredients, double price);
+//
+//    @Transactional
+//    void createMenu(Menu menu);
+//
+//    public void deleteMenu(long menuId);
+//
+//    @Transactional
+//    void deleteMenu(Menu menu);
+//
+//    public List<Menu> getCreatedMenus();
+//    public Menu findMenuById(long menuId);
+//    public void editMenu(long menuId, String name, String ingredients, double price);
 }
